## debug-me 1.20221231

=== Makefile ===
# The install target will add this before all paths it writes to.
PREFIX?=

# Can be "stack" or "cabal", or "./Setup" to build and use Setup.hs 
BUILDER?=stack

# Options to pass to the BUILDER.
# Using -j1 may result in a reproducible build.
BUILDEROPTIONS?=

# Propigate flags through ghc to linker and compiler.
ghc_options=$(shell \
	for w in $(LDFLAGS); do \
	       printf -- "-optl%s\n" "$$w"; \
	done; \
	for w in $(CFLAGS); do \
	       printf -- "-optc%s\n" "$$w"; \
	done; \
	for w in $(CPPFLAGS); do \
	       printf -- "-optc-Wp,%s\n" "$$w"; \
	done; \
	)

build:
	rm -f debug-me
	$(MAKE) debug-me

debug-me:
	if [ "$(BUILDER)" = ./Setup ]; then ghc --make Setup; fi
	if [ "$(BUILDER)" = stack ]; then \
		$(BUILDER) build --ghc-options="$(ghc_options)" $(BUILDEROPTIONS); \
	else \
		$(BUILDER) configure --ghc-options="$(ghc_options)"; \
		$(BUILDER) build $(BUILDEROPTIONS); \
	fi
	if [ "$(BUILDER)" = stack ]; then \
		ln -sf $$(stack path --dist-dir)/build/debug-me/debug-me debug-me; \
	else \
		ln -sf dist/build/debug-me/debug-me debug-me; \
	fi

clean:
	if [ "$(BUILDER)" != ./Setup ] && [ "$(BUILDER)" != cabal ]; then $(BUILDER) clean; fi
	rm -rf dist .stack-work tmp
	rm -f debig-me Build/LinuxMkLibs Setup
	find . -name \*.o -exec rm {} \;
	find . -name \*.hi -exec rm {} \;

install: install-files
	useradd --system debug-me
	chmod 700 $(DESTDIR)$(PREFIX)/var/log/debug-me
	chown debug-me:debug-me $(DESTDIR)$(PREFIX)/var/log/debug-me

install-files: debug-me install-mans
	install -d $(DESTDIR)$(PREFIX)/var/log/debug-me
	install -d $(DESTDIR)$(PREFIX)/usr/bin
	install -s -m 0755 debug-me $(DESTDIR)$(PREFIX)/usr/bin/debug-me
	install -d $(DESTDIR)$(PREFIX)/lib/systemd/system
	install -m 0644 debug-me.service $(DESTDIR)$(PREFIX)/lib/systemd/system/debug-me.service
	install -d $(DESTDIR)$(PREFIX)/etc/init.d
	install -m 0755 debug-me.init $(DESTDIR)$(PREFIX)/etc/init.d/debug-me
	install -d $(DESTDIR)$(PREFIX)/etc/default
	install -m 0644 debug-me.default $(DESTDIR)$(PREFIX)/etc/default/debug-me
	install -d $(DESTDIR)$(PREFIX)/usr/share/debug-me/keyring
	install -m 0655 developer-keyring.gpg \
		$(DESTDIR)$(PREFIX)/usr/share/debug-me/keyring/a_debug-me_developer.gpg

install-mans:
	install -d $(DESTDIR)$(PREFIX)/usr/share/man/man1
	install -m 0644 debug-me.1 $(DESTDIR)$(PREFIX)/usr/share/man/man1/debug-me.1

Build/LinuxMkLibs: Build/LinuxMkLibs.hs
	ghc --make $@ -Wall -fno-warn-tabs

LINUXSTANDALONE_DEST=tmp/debug-me
linuxstandalone: debug-me Build/LinuxMkLibs
	rm -rf "$(LINUXSTANDALONE_DEST)"
	mkdir -p tmp
	cp -R standalone/linux/skel "$(LINUXSTANDALONE_DEST)"
	install -d "$(LINUXSTANDALONE_DEST)/bin"
	cp debug-me "$(LINUXSTANDALONE_DEST)/bin/"
	strip "$(LINUXSTANDALONE_DEST)/bin/debug-me"
	./Build/LinuxMkLibs "$(LINUXSTANDALONE_DEST)"
	$(MAKE) install-mans DESTDIR="$(LINUXSTANDALONE_DEST)"
	cd tmp && tar c debug-me | gzip -9 --rsyncable > debug-me-standalone-$(shell dpkg --print-architecture).tar.gz

.PHONY: debug-me

## debug-me 1.20170810

=== debian/changelog ===
debug-me (1.20170810-2) unstable; urgency=medium

  * Bump graphviz dependency to 2999.20.*.
    Thanks to Gianfranco Costamagna for the patch.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 09 Jul 2018 10:35:06 +0100

debug-me (1.20170810-1) unstable; urgency=medium

  * New upstream release.
  * Bump std-ver to 4.0.1 (no changes required).

 -- Sean Whitton <spwhitton@spwhitton.name>  Thu, 10 Aug 2017 15:56:41 -0400

debug-me (1.20170520-1) unstable; urgency=medium

  * New upstream release.
  * Install debug-me developers' keyring into /usr/share/debug-me/keyring
    - New build-dep on dh-exec
    - d/debug-me.install now executable.
  * Symlink some Debian keyrings into /usr/share/debug-me/keyring.
    - Recommend debian-keyring package.
  * Expand long descriptions using manpage update in this release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Mon, 22 May 2017 21:07:50 +0100

debug-me (1.20170509-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Wed, 10 May 2017 08:59:23 -0700

debug-me (1.20170505-1) unstable; urgency=medium

  * Initial release (Closes: #861920).

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 09 May 2017 13:55:16 -0700

=== debian/control ===
Source: debug-me
Maintainer: Sean Whitton <spwhitton@spwhitton.name>
Priority: optional
Section: net
Build-Depends: debhelper (>= 10),
 dh-exec,
 ghc,
 libghc-aeson-dev (>= 0.11),
 libghc-aeson-dev (<< 1.3),
 libghc-async-dev (>= 2.1),
 libghc-cereal-dev (>= 0.5),
 libghc-cryptonite-dev (>= 0.20),
 libghc-graphviz-dev (>= 2999.18),
 libghc-graphviz-dev (<< 2999.21),
 libghc-http-client-dev (>= 0.4),
 libghc-http-client-tls-dev (>= 0.2),
 libghc-http-types-dev (>= 0.9),
 libghc-memory-dev (>= 0.13),
 libghc-mime-mail-dev (>= 0.4),
 libghc-network-dev (>= 2.6),
 libghc-network-uri-dev (>= 2.6),
 libghc-optparse-applicative-dev (>= 0.12),
 libghc-posix-pty-dev (>= 0.2.1),
 libghc-protobuf-dev (>= 0.2),
 libghc-sandi-dev (>= 0.4),
 libghc-stm-dev (>= 2.4),
 libghc-stm-chans-dev (>= 3.0),
 libghc-terminal-size-dev (>= 0.3),
 libghc-text-dev (>= 1.2.2),
 libghc-unbounded-delays-dev (>= 0.1),
 libghc-unordered-containers-dev (>= 0.2),
 libghc-utf8-string-dev (>= 1.0),
 libghc-uuid-dev (>= 1.3),
 libghc-wai-dev (>= 3.2),
 libghc-wai-websockets-dev (>= 3.0),
 libghc-warp-dev (>= 3.2),
 libghc-websockets-dev (>= 0.9),
Standards-Version: 4.0.1
Homepage: https://debug-me.branchable.com/
Vcs-Git: https://git.spwhitton.name/debug-me
Vcs-Browser: https://git.spwhitton.name/debug-me

Package: debug-me
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
Recommends: gnupg, debian-keyring
Description: secure remote debugging
 Debugging a problem over email/irc/BTS is slow, tedious, and
 hard. The developer needs to see the your problem to understand
 it. Debug-me aims to make debugging fast, fun, and easy, by letting
 the developer access your computer remotely, so they can immediately
 see and interact with the problem. Making your problem their problem
 gets it fixed fast.
 .
 A debug-me session is logged and signed with the developer's GnuPG
 key, producing a chain of evidence of what they saw and what they
 did. So the developer's good reputation is leveraged to make debug-me
 secure.  If you trust a developer to ship software to your computer,
 you can trust them to debug-me.
 .
 This package should be installed by desktop users -- both developers
 who want to debug, and users who want their problems debugged.  To
 set up a debug-me server, install the debug-me-server package.

Package: debug-me-server
Architecture: all
Depends: ${misc:Depends},
 debug-me,
 lsb-base (>= 3.0-6),
 adduser,
 default-mta | mail-transport-agent,
Description: run a debug-me server for secure remote debugging
 Debugging a problem over email/irc/BTS is slow, tedious, and
 hard. The developer needs to see the your problem to understand
 it. Debug-me aims to make debugging fast, fun, and easy, by letting
 the developer access your computer remotely, so they can immediately
 see and interact with the problem. Making your problem their problem
 gets it fixed fast.
 .
 A debug-me session is logged and signed with the developer's GnuPG
 key, producing a chain of evidence of what they saw and what they
 did. So the developer's good reputation is leveraged to make debug-me
 secure.  If you trust a developer to ship software to your computer,
 you can trust them to debug-me.
 .
 This package sets up a debug-me server.  If you don't want to do
 that, install only the debug-me package.

## debug-me 1.20181208

=== debian/changelog ===
debug-me (1.20181208-2) unstable; urgency=medium

  * Remove recursive chown from the postinst.
    The situation in which I (presumably) thought it would be needed
    cannot actually arise; see comments in the postinst.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 08 Dec 2018 16:56:33 -0700

debug-me (1.20181208-1) unstable; urgency=medium

  * New upstream release.
    - Update build-dep bounds.
  * Drop build-dep on haskell-stm.
  * Build-dep on ghc (>= 8.4.3), with which haskell-stm is now bundled.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 08 Dec 2018 12:21:04 -0700

=== debian/control ===
--- 
+++ 
@@ -4,13 +4,13 @@
 Section: net
 Build-Depends: debhelper (>= 10),
  dh-exec,
- ghc,
+ ghc (>= 8.4.3),
  libghc-aeson-dev (>= 0.11),
- libghc-aeson-dev (<< 1.3),
+ libghc-aeson-dev (<< 1.4),
  libghc-async-dev (>= 2.1),
  libghc-cereal-dev (>= 0.5),
  libghc-cryptonite-dev (>= 0.20),
- libghc-graphviz-dev (>= 2999.18),
+ libghc-graphviz-dev (>= 2999.18.0),
  libghc-graphviz-dev (<< 2999.21),
  libghc-http-client-dev (>= 0.4),
  libghc-http-client-tls-dev (>= 0.2),
@@ -23,7 +23,6 @@
  libghc-posix-pty-dev (>= 0.2.1),
  libghc-protobuf-dev (>= 0.2),
  libghc-sandi-dev (>= 0.4),
- libghc-stm-dev (>= 2.4),
  libghc-stm-chans-dev (>= 3.0),
  libghc-terminal-size-dev (>= 0.3),
  libghc-text-dev (>= 1.2.2),

## debug-me 1.20190926

=== debian/changelog ===
debug-me (1.20190926-1build2) focal; urgency=medium

  * No-change rebuild with fixed binutils on arm64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 08 Feb 2020 10:57:52 +0000

debug-me (1.20190926-1build1) focal; urgency=medium

  * No-change rebuild for libffi soname change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 12 Jan 2020 08:48:31 +0000

debug-me (1.20190926-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 28 Sep 2019 10:51:54 -0700

debug-me (1.20181208-3) unstable; urgency=medium

  * Bump dependency bounds
  * Patch to fix xmonad failure

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 08 Aug 2019 16:30:19 +0200

=== debian/rules ===
#!/usr/bin/make -f

# Debian's ghc cannot compile anything with -fPIC at present, so we
# have to disable PIE hardening to avoid build failures on archs like
# amd64.  See discussion on debian-haskell@lists.debian.org
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie

# cabal likes to write to $HOME, so use Setup.hs directly
export BUILDER = ./Setup

# -j1 in the hope of making the build reproducible (see Makefile)
export BUILDEROPTIONS = -j1

%:
	dh $@

# upstream's install-files target is not sufficient for our split into
# two binary packages, so disable it here and use dh_* tools
override_dh_auto_install:

# GHC cannot produce debugging symbols
override_dh_strip:
	dh_strip --no-automatic-dbgsym

# ensure service name is 'debug-me' not 'debug-me-server'.  This is so
# we are consistent with other distros despite our package split
override_dh_installinit:
	dh_installinit --name=debug-me

## debug-me 1.20200820

=== debian/changelog ===
debug-me (1.20200820-1) unstable; urgency=medium

  * New upstream release (Closes: #968717).

 -- Sean Whitton <spwhitton@spwhitton.name>  Sat, 22 Aug 2020 07:46:36 -0700

debug-me (1.20190926-2) unstable; urgency=medium

  * Fix build (Closes: #963862):
    - Patch Val.hs for recent ghc: replace type constraint Monad -> MonadFail
    - Patch Server.hs for recent Network.WebSockets: hide import of
      Network.WebSockets.serverPort.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 14 Jul 2020 19:44:25 -0700

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  dh-exec,
  ghc (>= 8.4.3),
  libghc-aeson-dev (>= 0.11),
- libghc-aeson-dev (<< 1.4),
+ libghc-aeson-dev (<< 1.5),
  libghc-async-dev (>= 2.1),
  libghc-cereal-dev (>= 0.5),
  libghc-cryptonite-dev (>= 0.20),

## debug-me 1.20220324

=== debian/changelog ===
debug-me (1.20220324-1) unstable; urgency=medium

  * New upstream release.
  * Update build-dep bounds for libghc-aeson-dev and libghc-websockets-dev.

 -- Sean Whitton <spwhitton@spwhitton.name>  Sun, 22 May 2022 14:58:59 -0700

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  dh-exec,
  ghc (>= 8.4.3),
  libghc-aeson-dev (>= 0.11),
- libghc-aeson-dev (<< 1.5),
+ libghc-aeson-dev (<< 2.1),
  libghc-async-dev (>= 2.1),
  libghc-cereal-dev (>= 0.5),
  libghc-cryptonite-dev (>= 0.20),
@@ -33,7 +33,7 @@
  libghc-wai-dev (>= 3.2),
  libghc-wai-websockets-dev (>= 3.0),
  libghc-warp-dev (>= 3.2),
- libghc-websockets-dev (>= 0.9),
+ libghc-websockets-dev (>= 0.12.6.0),
 Standards-Version: 4.0.1
 Homepage: https://debug-me.branchable.com/
 Vcs-Git: https://git.spwhitton.name/debug-me

## debug-me 1.20221231

=== debian/changelog ===
debug-me (1.20221231-2.1build1) resolute; urgency=medium

  * Rebuild against new GHC ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 01 Nov 2025 08:55:42 +0100

debug-me (1.20221231-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * No source change upload to move systemd units into /usr.

 -- Chris Hofstaedtler <zeha@debian.org>  Mon, 27 May 2024 01:11:19 +0200

debug-me (1.20221231-2) unstable; urgency=medium

  * Disable link time optimisation on ppc64el (Closes: #1052313).
    Thanks to Heinrich Schuchardt for the patch.
  * Bump Aeson dependency bounds to allow 2.1 (Closes: #1054930).

 -- Sean Whitton <spwhitton@spwhitton.name>  Fri, 03 Nov 2023 10:21:15 +0000

debug-me (1.20221231-1) unstable; urgency=medium

  * New upstream release.

 -- Sean Whitton <spwhitton@spwhitton.name>  Tue, 04 Jul 2023 16:38:00 +0100

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  dh-exec,
  ghc (>= 8.4.3),
  libghc-aeson-dev (>= 0.11),
- libghc-aeson-dev (<< 2.1),
+ libghc-aeson-dev (<< 2.2),
  libghc-async-dev (>= 2.1),
  libghc-cereal-dev (>= 0.5),
  libghc-cryptonite-dev (>= 0.20),

=== debian/rules ===
--- 
+++ 
@@ -1,9 +1,18 @@
 #!/usr/bin/make -f
+
+DPKG_EXPORT_BUILDFLAGS := 1
+include /usr/share/dpkg/architecture.mk
 
 # Debian's ghc cannot compile anything with -fPIC at present, so we
 # have to disable PIE hardening to avoid build failures on archs like
 # amd64.  See discussion on debian-haskell@lists.debian.org
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
+DEB_BUILD_MAINT_OPTIONS = hardening=+all,-pie
+
+# Building with LTO failed on ppc64el (LP: #2033639)
+ifeq ("$(DEB_BUILD_ARCH)", "ppc64el")
+	DEB_BUILD_MAINT_OPTIONS += optimize=-lto
+endif
+export DEB_BUILD_MAINT_OPTIONS
 
 # cabal likes to write to $HOME, so use Setup.hs directly
 export BUILDER = ./Setup

=== debian/watch ===
version=3
http://hackage.haskell.org/package/debug-me/distro-monitor .*-([0-9\.]+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
